package net.locusworks.worldcities;

import java.io.IOException;
import java.util.List;
import java.util.stream.Collectors;

import net.locusworks.worldcities.csv.CityFileReader;
import net.locusworks.worldcities.entities.City;

public class WorldCities {
  
  private static List<City> WORLD_CITY_LIST;
  static {
    try {
      WORLD_CITY_LIST = CityFileReader.readCities();
    } catch (IOException e) {
      throw new RuntimeException(e);
    }
  }
  
  public static City findByCityName(String cityName) {
    return WORLD_CITY_LIST.stream().filter(c -> c.getCityName().equalsIgnoreCase(cityName))
        .findFirst().orElse(null);
  }
  
  public static City findByCityAndCountry(String cityName, String country) {
    return WORLD_CITY_LIST.stream()
        .filter(c -> c.getCityName().equalsIgnoreCase(cityName))
        .filter(c -> c.getCountryName().equalsIgnoreCase(country))
        .findFirst().orElse(null);
  }
  
  public static List<City> findByCityNameLike(String cityName) {
    return WORLD_CITY_LIST.stream().filter(c -> c.getCityName().toLowerCase()
        .contains(cityName.toLowerCase())).collect(Collectors.toList());
  }
  
  public static List<City> findCitiesByCountry(String countryName) {
    return WORLD_CITY_LIST.stream().filter(c -> c.getCountryName()
        .equalsIgnoreCase(countryName.toLowerCase())).collect(Collectors.toList());
  }

}
